/*
 * GUIConnection.java
 *
 * Created on 27 de agosto de 2007, 23:51
 */

package madagascar;

import cube.common.postman.Postman;
import cube.common.util.util;
import java.awt.Component;
import java.awt.Cursor;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.security.cert.X509Certificate;
import java.util.Enumeration;
import java.util.Properties;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.ListCellRenderer;

/**
 *
 * @author  victor
 */
public class GUIConnection extends javax.swing.JDialog {
    /**
     * Indica si se pulso aceptar (action = 1) o cancelar (action = 0)
     */
    private int action = 0;
    /**
     * Indica el certificado seleccionado.
     * -1 si no se selecciono ninguno.
     */
    private int seleccionado = -1;
    
    /**********************************************************
     * CONDICIONES BOOLEANAS PARA HABILITAR EL BONTON ACEPTAR:
     **********************************************************/
    //Se ha escrito un host.
    private boolean host_ok = false;
    //Se ha escrito un puerto interno:
    private boolean port_int_ok = true;
    //Se ha escrito un puerto externo:
    private boolean port_ext_ok = true;
    //Se ha escrito el nombre del anillo:
    private boolean name_ring = false;
    //Archivo ring.param existente:
    private boolean ring_param_exist = true;
    
    /**********************************************************
     * PARAMETROS DE CONFIGURACION DEL ANILLO:
     **********************************************************/
    private Properties ring_param = new Properties();
    //Archivo con los parametros a cargas:
    private String ring_param_file = Postman.getCubeDirectoryRoot()+File.separator+Postman.directoryComfig+File.separator+Postman.RING_PARAM_FILE;
    
    
    //Puerto de escucha local:
    private int localport = 8429;
    //Puerto de la maquina destino:
    private int destport = 8429;
    
    /** Constructor de la clase */
    public GUIConnection(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        TxHost.setText(GUI.madagascarConf.getProperty("ipnode"));
        TxPort.setText(GUI.madagascarConf.getProperty("destinyPort"));
        TxLocalPort.setText(GUI.madagascarConf.getProperty("localPort"));
        ringName.setText(GUI.madagascarConf.getProperty("ringname"));
        refreshLista();
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        grupo = new javax.swing.ButtonGroup();
        Image = new javax.swing.JLabel();
        BtOk = new javax.swing.JButton();
        BtCancel = new javax.swing.JButton();
        panel = new javax.swing.JTabbedPane();
        panelConexion = new javax.swing.JPanel();
        panel_conexion = new javax.swing.JPanel();
        TxHost = new javax.swing.JTextField();
        LbTituloHost = new javax.swing.JLabel();
        LbTituloPuerto = new javax.swing.JLabel();
        LbTituloLocal = new javax.swing.JLabel();
        TxLocalPort = new javax.swing.JTextField();
        TxPort = new javax.swing.JTextField();
        jPanel3 = new javax.swing.JPanel();
        crearAnillo = new javax.swing.JCheckBox();
        ringLan = new javax.swing.JRadioButton();
        ringInternet = new javax.swing.JRadioButton();
        lbTituloNombreAnillo = new javax.swing.JLabel();
        ringName = new javax.swing.JTextField();
        panelNAT = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        LbTituloIPExterna = new javax.swing.JLabel();
        upnp = new javax.swing.JCheckBox();
        TxIPexterna = new javax.swing.JTextField();
        texto1 = new javax.swing.JLabel();
        texto2 = new javax.swing.JLabel();
        texto3 = new javax.swing.JLabel();
        texto4 = new javax.swing.JLabel();
        probeExternal = new javax.swing.JCheckBox();
        BtActualizar = new javax.swing.JButton();
        panelIdentificacion = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        lista = new javax.swing.JList();
        jLabel1 = new javax.swing.JLabel();
        certificados = new javax.swing.JCheckBox();

        setTitle("Conectar con un nodo:");
        setModal(true);
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowActivated(java.awt.event.WindowEvent evt) {
                formWindowActivated(evt);
            }
        });

        Image.setIcon(new javax.swing.ImageIcon(getClass().getResource("/madagascar/recursos/network_local_128x128.png")));

        BtOk.setIcon(new javax.swing.ImageIcon(getClass().getResource("/madagascar/recursos/button_ok_16x16.png")));
        BtOk.setText("Aceptar");
        BtOk.setEnabled(false);
        BtOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BtOkActionPerformed(evt);
            }
        });

        BtCancel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/madagascar/recursos/button_cancel_16x16.png")));
        BtCancel.setText("Cancelar");
        BtCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BtCancelActionPerformed(evt);
            }
        });

        panel_conexion.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createTitledBorder("Datos de conexi\u00f3n")));
        TxHost.addCaretListener(new javax.swing.event.CaretListener() {
            public void caretUpdate(javax.swing.event.CaretEvent evt) {
                TxHostCaretUpdate(evt);
            }
        });

        LbTituloHost.setText("Host: ");

        LbTituloPuerto.setText("Puerto destino: ");

        LbTituloLocal.setText("Puerto local: ");

        TxLocalPort.setText("8429");
        TxLocalPort.addCaretListener(new javax.swing.event.CaretListener() {
            public void caretUpdate(javax.swing.event.CaretEvent evt) {
                TxLocalPortCaretUpdate(evt);
            }
        });

        TxPort.setText("8429");
        TxPort.addCaretListener(new javax.swing.event.CaretListener() {
            public void caretUpdate(javax.swing.event.CaretEvent evt) {
                TxPortCaretUpdate(evt);
            }
        });

        javax.swing.GroupLayout panel_conexionLayout = new javax.swing.GroupLayout(panel_conexion);
        panel_conexion.setLayout(panel_conexionLayout);
        panel_conexionLayout.setHorizontalGroup(
            panel_conexionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panel_conexionLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(panel_conexionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(panel_conexionLayout.createSequentialGroup()
                        .addComponent(LbTituloHost)
                        .addGap(88, 88, 88)
                        .addComponent(TxHost, javax.swing.GroupLayout.DEFAULT_SIZE, 411, Short.MAX_VALUE))
                    .addGroup(panel_conexionLayout.createSequentialGroup()
                        .addGroup(panel_conexionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(LbTituloLocal)
                            .addComponent(LbTituloPuerto))
                        .addGap(26, 26, 26)
                        .addGroup(panel_conexionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(TxLocalPort)
                            .addComponent(TxPort, javax.swing.GroupLayout.DEFAULT_SIZE, 56, Short.MAX_VALUE))))
                .addContainerGap())
        );
        panel_conexionLayout.setVerticalGroup(
            panel_conexionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panel_conexionLayout.createSequentialGroup()
                .addGroup(panel_conexionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(LbTituloHost)
                    .addComponent(TxHost, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(panel_conexionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(LbTituloPuerto)
                    .addComponent(TxPort, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(panel_conexionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(LbTituloLocal)
                    .addComponent(TxLocalPort, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(14, Short.MAX_VALUE))
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("Crear un anillo"));
        crearAnillo.setText("Crear un nuevo anillo.");
        crearAnillo.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        crearAnillo.setMargin(new java.awt.Insets(0, 0, 0, 0));
        crearAnillo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                crearAnilloActionPerformed(evt);
            }
        });

        grupo.add(ringLan);
        ringLan.setText(" Accesible SOLO desde la red local.");
        ringLan.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        ringLan.setEnabled(false);
        ringLan.setMargin(new java.awt.Insets(0, 0, 0, 0));

        grupo.add(ringInternet);
        ringInternet.setSelected(true);
        ringInternet.setText(" Accesible tras el NAT.");
        ringInternet.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        ringInternet.setEnabled(false);
        ringInternet.setMargin(new java.awt.Insets(0, 0, 0, 0));

        lbTituloNombreAnillo.setText("Nombre del anillo:");

        ringName.setToolTipText("Debe estar entre 6 y 100 car\u00e1cteres.");
        ringName.setEnabled(false);
        ringName.addCaretListener(new javax.swing.event.CaretListener() {
            public void caretUpdate(javax.swing.event.CaretEvent evt) {
                ringNameCaretUpdate(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(crearAnillo)
                    .addComponent(ringInternet)
                    .addComponent(ringLan)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(lbTituloNombreAnillo)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(ringName, javax.swing.GroupLayout.DEFAULT_SIZE, 417, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(crearAnillo)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(ringInternet)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(ringLan)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lbTituloNombreAnillo)
                    .addComponent(ringName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(51, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout panelConexionLayout = new javax.swing.GroupLayout(panelConexion);
        panelConexion.setLayout(panelConexionLayout);
        panelConexionLayout.setHorizontalGroup(
            panelConexionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, panelConexionLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(panelConexionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel3, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(panel_conexion, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        panelConexionLayout.setVerticalGroup(
            panelConexionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelConexionLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(panel_conexion, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        panel.addTab("Conexi\u00f3n", panelConexion);

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Configuracion del Firewall"));
        LbTituloIPExterna.setText("IP externa del equipo:");

        upnp.setText("Activar sistema Upnp");
        upnp.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        upnp.setMargin(new java.awt.Insets(0, 0, 0, 0));
        upnp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                upnpActionPerformed(evt);
            }
        });

        TxIPexterna.setEditable(false);
        TxIPexterna.setText("0.0.0.0");

        texto1.setText("Mediante el protocolo Upnp se interact\u00faa con el router y se puede obtener la IP ");

        texto2.setText("externa y realizar el Port forwarding. NO FUNCIONA EN TODOS LOS ROUTER. ");

        texto3.setText("Si no se activa la opci\u00f3n Upnp o tiene problemas con ella, debes asegurarte de ");

        texto4.setText("abrir el puerto de escucha tipo TCP/UDP en el router y redirigirlo a tu maquina.");

        probeExternal.setText("Usar el nodo de enlace para obtener la IP externa.");
        probeExternal.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        probeExternal.setMargin(new java.awt.Insets(0, 0, 0, 0));
        probeExternal.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                probeExternalActionPerformed(evt);
            }
        });

        BtActualizar.setText("Actualizar");
        BtActualizar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BtActualizarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(LbTituloIPExterna)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(TxIPexterna, javax.swing.GroupLayout.PREFERRED_SIZE, 194, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(BtActualizar))
                    .addComponent(upnp)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGap(17, 17, 17)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(texto2)
                            .addComponent(texto1)
                            .addComponent(texto3)
                            .addComponent(texto4)))
                    .addComponent(probeExternal))
                .addContainerGap(41, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(LbTituloIPExterna)
                    .addComponent(TxIPexterna, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(BtActualizar))
                .addGap(17, 17, 17)
                .addComponent(upnp)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(texto1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(texto2)
                .addGap(29, 29, 29)
                .addComponent(texto3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(texto4)
                .addGap(19, 19, 19)
                .addComponent(probeExternal)
                .addContainerGap(54, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout panelNATLayout = new javax.swing.GroupLayout(panelNAT);
        panelNAT.setLayout(panelNATLayout);
        panelNATLayout.setHorizontalGroup(
            panelNATLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelNATLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        panelNATLayout.setVerticalGroup(
            panelNATLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelNATLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        panel.addTab("NAT", panelNAT);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Tipo de identificaci\u00f3n"));
        lista.setCellRenderer(new MyCellRenderer_cert());
        lista.setEnabled(false);
        jScrollPane1.setViewportView(lista);

        jLabel1.setText("Elige el certificado con el que conectar:");

        certificados.setText("Usar certificados.");
        certificados.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        certificados.setMargin(new java.awt.Insets(0, 0, 0, 0));
        certificados.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                certificadosActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 543, Short.MAX_VALUE)
                    .addComponent(jLabel1)
                    .addComponent(certificados))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap(16, Short.MAX_VALUE)
                .addComponent(certificados)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(26, 26, 26))
        );

        javax.swing.GroupLayout panelIdentificacionLayout = new javax.swing.GroupLayout(panelIdentificacion);
        panelIdentificacion.setLayout(panelIdentificacionLayout);
        panelIdentificacionLayout.setHorizontalGroup(
            panelIdentificacionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelIdentificacionLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        panelIdentificacionLayout.setVerticalGroup(
            panelIdentificacionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelIdentificacionLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(61, Short.MAX_VALUE))
        );
        panel.addTab("Identificaci\u00f3n", panelIdentificacion);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(243, 243, 243)
                .addComponent(Image)
                .addContainerGap(259, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(404, Short.MAX_VALUE)
                .addComponent(BtOk)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(BtCancel)
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(panel, javax.swing.GroupLayout.PREFERRED_SIZE, 606, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(Image)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(panel, javax.swing.GroupLayout.PREFERRED_SIZE, 339, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(21, 21, 21)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(BtOk)
                    .addComponent(BtCancel))
                .addContainerGap(21, Short.MAX_VALUE))
        );
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-640)/2, (screenSize.height-569)/2, 640, 569);
    }// </editor-fold>//GEN-END:initComponents

    private void ringNameCaretUpdate(javax.swing.event.CaretEvent evt) {//GEN-FIRST:event_ringNameCaretUpdate
        if(ringName.getText().length()<6) name_ring = false;
        else name_ring = true;
        verifyOkButton();
    }//GEN-LAST:event_ringNameCaretUpdate

    private void crearAnilloActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_crearAnilloActionPerformed
        if(crearAnillo.isSelected())
        {
            ringLan.setEnabled(true);
            ringInternet.setEnabled(true);
            ringName.setEnabled(true);
        }
        else
        {
            ringLan.setEnabled(false);
            ringInternet.setEnabled(false);
            ringName.setEnabled(false);
        }
        verifyOkButton();
    }//GEN-LAST:event_crearAnilloActionPerformed

    private void upnpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_upnpActionPerformed
        if(upnp.isSelected())
        {
            ring_param.setProperty("nat_search_policy","always");
            ring_param.remove("external_address");
        }
        else
        {
            ring_param.setProperty("nat_search_policy","never");
            //ring_param.setProperty("external_address","");
        }
    }//GEN-LAST:event_upnpActionPerformed

    private void probeExternalActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_probeExternalActionPerformed
        //Indicamos si se desea emplear el nodo destino para obtener la IP externa de mi maquina:
        if(probeExternal.isSelected()) ring_param.setProperty("probe_for_external_address","true");
        else ring_param.setProperty("probe_for_external_address","never");
    }//GEN-LAST:event_probeExternalActionPerformed
/**
 * Acciones a realizar cada vez que se abre la ventana:
 */
    private void formWindowActivated(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowActivated
        TxIPexterna.setText(getExternalIP());
        try {
            FileInputStream fin = new FileInputStream(ring_param_file);
            
            ring_param.load(fin);
            fin.close();
            
            String valor;
            
            //probe_for_external_address:
            valor = ring_param.getProperty("probe_for_external_address");
            if(valor == null) ring_param.setProperty("probe_for_external_address","never");
            if(valor.equals("true")) probeExternal.setSelected(true); else probeExternal.setSelected(false);
            
             //Uso del upnp:
            if(ring_param.getProperty("nat_search_policy").equals("always"))
            {
               ring_param.remove("external_address");
               upnp.setSelected(true);
            }
            else
            {
                upnp.setSelected(false);
            }
            
        } 
        catch (FileNotFoundException ex) 
        {
            if(ring_param_exist)
            JOptionPane.showMessageDialog(this,"No se encuentra el archivo "+Postman.RING_PARAM_FILE+".\nRevise la instalación de la aplicación."
                                                  ,"Error",JOptionPane.INFORMATION_MESSAGE);
            ring_param_exist = false;
        }
        catch (IOException ex){}
    }//GEN-LAST:event_formWindowActivated

    private void TxLocalPortCaretUpdate(javax.swing.event.CaretEvent evt) {//GEN-FIRST:event_TxLocalPortCaretUpdate
        if(TxLocalPort.getText().length()>0) port_int_ok = true; else  port_int_ok = false;
           verifyOkButton();
    }//GEN-LAST:event_TxLocalPortCaretUpdate

    private void TxPortCaretUpdate(javax.swing.event.CaretEvent evt) {//GEN-FIRST:event_TxPortCaretUpdate
        if(TxPort.getText().length()>0) port_ext_ok = true; else  port_ext_ok = false;
           verifyOkButton();
    }//GEN-LAST:event_TxPortCaretUpdate

    private void TxHostCaretUpdate(javax.swing.event.CaretEvent evt) {//GEN-FIRST:event_TxHostCaretUpdate
           if(TxHost.getText().length()>0) host_ok = true; else  host_ok = false;
           verifyOkButton();
           
    }//GEN-LAST:event_TxHostCaretUpdate

    private void BtActualizarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BtActualizarActionPerformed
        this.setCursor(new Cursor(Cursor.WAIT_CURSOR));
        TxIPexterna.setText(getExternalIP());
        this.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
    }//GEN-LAST:event_BtActualizarActionPerformed

    private void certificadosActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_certificadosActionPerformed
        if(certificados.isSelected())
            lista.setEnabled(true);
        else
            lista.setEnabled(false);
    }//GEN-LAST:event_certificadosActionPerformed

    private void BtCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BtCancelActionPerformed
        action = 0;
        ring_param_exist = true;
        setVisible(false);
    }//GEN-LAST:event_BtCancelActionPerformed

    private void BtOkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BtOkActionPerformed
        GUI.madagascarConf.setProperty("ipnode",TxHost.getText());
        GUI.madagascarConf.setProperty("destinyPort",TxPort.getText());
        GUI.madagascarConf.setProperty("localPort",TxLocalPort.getText());
        GUI.madagascarConf.setProperty("ringname",ringName.getText());
        try
        {
            localport = Integer.parseInt(TxLocalPort.getText());
            destport = Integer.parseInt(TxPort.getText());
        }
        catch (NumberFormatException ex)
        {
            JOptionPane.showMessageDialog(this,"Los puertos son un rango numérico desde 1000 al 65535.","Error",JOptionPane.ERROR_MESSAGE);
            return;
        }
        
        if(localport<1000 || localport>65535 || destport<1000 || destport>65535)
        {
            JOptionPane.showMessageDialog(this,"Los puertos son un rango numérico desde 1000 al 65535.","Error",JOptionPane.ERROR_MESSAGE);
            return;
        }
        
        try 
        {
            if(!upnp.isSelected())
                if(!TxIPexterna.getText().equals("0.0.0.0") && (!crearAnillo.isSelected() || (crearAnillo.isSelected() &&  ringInternet.isSelected()) ))
                {
                    ring_param.setProperty("external_address",TxIPexterna.getText()+":"+localport);
                }
                else ring_param.remove("external_address");
            //Almacenamos los cambios:
            saveProperties();
        } catch (FileNotFoundException ex) {
            JOptionPane.showMessageDialog(this,"No se encuentra ring.params","Error",JOptionPane.ERROR_MESSAGE);
             action = 0; 
             return;
        } catch (IOException ex) {
            JOptionPane.showMessageDialog(this,"Se ha producido un error durante la escritura en "+Postman.RING_PARAM_FILE,"Error",JOptionPane.ERROR_MESSAGE);
             action = 0; 
             return;
        }
        
        /***************************************
         * Seleccion de certifcados:
         ***************************************/
        //Si no deseamos usar certificados:
        if(!certificados.isSelected()) {action = 1; this.setVisible(false); return;}
        
        seleccionado = lista.getSelectedIndex();
        if(seleccionado>=0)
        {
             if(((MyListElement_cert)lista.getModel().getElementAt(seleccionado)).certSort())
             {
                 JOptionPane.showMessageDialog(this,"No puedes seleccionar certificados tipo CA para identificarte."
                                                  ,"Error",JOptionPane.ERROR_MESSAGE);
             }
             else
             {
                action = 1; 
                this.setVisible(false);
             }
        }
    }//GEN-LAST:event_BtOkActionPerformed
    
    /**
     * Vuelca a ring.params los cambios hechos en la configuracion del anillo.
     * @throws java.io.FileNotFoundException No se encuentra ring.params.
     * @throws java.io.IOException Error tipo I/O al escribir en el archivo ring.params.
     */
    private void saveProperties() throws FileNotFoundException, IOException
    {
            FileOutputStream fout = new FileOutputStream(ring_param_file);
            ring_param.store(fout,"Archivo de configuracion del anillo.");  
    }
    
    /**
     *Permite consultar la accion del usuario:<br> 0 Boton cancelar. 1 Boton aceptar.
     */
    int getAction(){return action;}    
    /**
     * Obtiene el host introducido por el usuario.
     */
    String getHost(){ return this.TxHost.getText(); }
    /**
     * Obtiene el puerto destino introducido por el usuario.
     */
    int getPort(){ return destport; }
     /**
     * Obtiene el puerto local introducido por el usuario.
     */
    int getLocalPort() { return localport; }
     /**
     * Obtiene el certificado seleccionado por el usuario.
     */
    X509Certificate getCert(){ return  ((MyListElement_cert)lista.getModel().getElementAt(seleccionado)).getCert(); }
     /**
     * Indican si el usuario a elegido identificarse con certificados.
     */
    boolean useCert() { return certificados.isSelected();}
    /**
     * Indica si el usuario ha elegido crear un anillo.
     */
    boolean createRing(){ return crearAnillo.isSelected(); }
    /**
     * Devuelve el nombre del anillo.
     */
    String getNameRing()
    {
        if(ringName.getText().length()<=100) return ringName.getText();
        else return ringName.getText().substring(0,100);
    }
    
    /**
     * Refresca la lista de los certificados.
     */
    private void refreshLista()
    {
        Vector<MyListElement_cert> elementosLista = new Vector();
        Enumeration<String> enumeracion = Postman.GetRefCryptography().getAliases();
        
        while(enumeracion.hasMoreElements())
        {
             String alias = enumeracion.nextElement();
             X509Certificate elCertificado = Postman.GetRefCryptography().getCertificate(alias);
             String [] datos = elCertificado.getSubjectX500Principal().toString().split(",");
             elementosLista.add(new MyListElement_cert(datos[1],alias ,Postman.GetRefCryptography().isCAcert(alias),elCertificado));
        }
       
        lista.setListData(elementosLista);
        lista.repaint();
    }
    
    /**
     * Obtiene la IP externa del equipo.
     */
    private String getExternalIP()
    {
        String ip = util.netExternalIPAddress();
        if(ip==null) 
        { 
            JOptionPane.showMessageDialog(this,"Ha ocurrido un error al obtener la IP externa. Inténtelo de nuevo\no acuda al area de " +
                    "support tools de cube-grid.sourceforge.net.","Error",JOptionPane.ERROR_MESSAGE);
            return "0.0.0.0";
        }
        else return ip;
    }
    
    /**
     * Verifica si es posible habilitar el bonton de aceptar.
     * Para ello es necesario introducir de forma correcta los parametros.
     */
    private void verifyOkButton()
    {
        if(!crearAnillo.isSelected())
        {
            if(ring_param_exist && host_ok && port_ext_ok && port_int_ok) { BtOk.setEnabled(true); return; }
        }
        else
        if(ring_param_exist && host_ok && port_ext_ok && port_int_ok && name_ring) { BtOk.setEnabled(true); return; }
        
        BtOk.setEnabled(false);
            
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton BtActualizar;
    private javax.swing.JButton BtCancel;
    private javax.swing.JButton BtOk;
    private javax.swing.JLabel Image;
    private javax.swing.JLabel LbTituloHost;
    private javax.swing.JLabel LbTituloIPExterna;
    private javax.swing.JLabel LbTituloLocal;
    private javax.swing.JLabel LbTituloPuerto;
    private javax.swing.JTextField TxHost;
    private javax.swing.JTextField TxIPexterna;
    private javax.swing.JTextField TxLocalPort;
    private javax.swing.JTextField TxPort;
    private javax.swing.JCheckBox certificados;
    private javax.swing.JCheckBox crearAnillo;
    private javax.swing.ButtonGroup grupo;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel lbTituloNombreAnillo;
    private javax.swing.JList lista;
    private javax.swing.JTabbedPane panel;
    private javax.swing.JPanel panelConexion;
    private javax.swing.JPanel panelIdentificacion;
    private javax.swing.JPanel panelNAT;
    private javax.swing.JPanel panel_conexion;
    private javax.swing.JCheckBox probeExternal;
    private javax.swing.JRadioButton ringInternet;
    private javax.swing.JRadioButton ringLan;
    private javax.swing.JTextField ringName;
    private javax.swing.JLabel texto1;
    private javax.swing.JLabel texto2;
    private javax.swing.JLabel texto3;
    private javax.swing.JLabel texto4;
    private javax.swing.JCheckBox upnp;
    // End of variables declaration//GEN-END:variables
    
}

/**
 *  INNER CLASS
 */
/*
 class MyCellRenderer_cert extends JLabel implements ListCellRenderer {
     //Imagen paquete seleccionado:
     private final  ImageIcon iconCA = new javax.swing.ImageIcon(getClass().getResource("/madagascar/recursos/newspaper_go_16x16.png"));
     //Imagen paquete No seleccionado:
     private final  ImageIcon iconCert = new javax.swing.ImageIcon(getClass().getResource("/madagascar/recursos/newspaper_16x16.png"));
    // private Vector<String> toinstall;
     
     //public void setDataToInstal(Vector<String> data){this.toinstall = data;}

     public Component getListCellRendererComponent(
       JList list,              // the list
       Object value,            // value to display
       int index,               // cell index
       boolean isSelected,      // is the cell selected
       boolean cellHasFocus)    // does the cell have focus
     {
         
         
          setBackground(list.getBackground());
          setForeground(list.getForeground());
             
         if( ((MyListElement_cert)value).certSort()) setIcon(iconCA);
         else setIcon(iconCert);
         
    
         String s = value.toString();
         setText(s);
            
         setEnabled(list.isEnabled());
         setFont(list.getFont());
         setOpaque(true);
         return this;
     }
 }/*
 
 /**
  * Elemento del jlist. Simplemente es una clase que almacena si un objetos se selecciono
  * para actualizar.
  */
/* class MyListElement_cert
 {
     //Titulo del elemento:
     private String texto = "";
     //Certificado_
     private X509Certificate cert;
     //Alias del certificado:
     private String alias = "";
     /**
      * Tipo de certificado:
      * True: CA.
      * FAlse: Certificado de usuario.
      */
    /* private boolean tipo = false;

        
     public MyListElement_cert(String texto, String alias, boolean tipo, X509Certificate cert)
     {this.alias = alias; this.texto = texto; this.tipo = tipo; this.cert = cert;}
          
     /**
      * Permite consultar el tipo de certificado.
      * @return true Si es tipo CA.
      * @return false Certificado de usuario.
      */
   /*  public boolean certSort() { return tipo; }
     
     /**
      * Obtiene el certificado asociado al elemento.
      */
    // public X509Certificate getCert() { return cert;}
     
     /**
      * Obtiene el alias del certificado asociado a la entrada.
      */
     //public String getAlias(){ return alias; }

     /**
      * Texto del elemento.
      */
     //public String toString() { return "["+alias+"]"+texto; }
// }
