/*
 * GUIUpdate.java
 *
 * Created on 18 de octubre de 2007, 10:40
 */

package madagascar;


import cube.common.postman.Postman;
import cube.common.updater.PackageData;
import cube.common.updater.Updater;
import cube.common.util.Pair;
import cube.common.util.util;
import java.awt.Color;
import java.awt.Component;
import java.awt.Cursor;
import java.awt.Frame;
import java.io.File;
import java.io.IOException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JRadioButton;
import javax.swing.ListCellRenderer;
import org.apache.commons.io.FileUtils;

/**
 *
 * @author  victor
 */
public class GUIUpdate extends javax.swing.JDialog {
    
    /**
     * Prefijo para los archivos temporales generados por el updater.
     */
    static public final String tempFilesPrefix ="madagascar_updater";
    
    /**
     * URL del archivo XML con informacion de las actualizaciones.
     */
    static private final String URL_UPDATER = "http://cube-grid.sourceforge.net/update/update_info.xml";
    
    //Almacena el numero de paquetes seleccionados:
    private int selectPackageCount = 0;
   
    /**
    * Informacion de los paquetes extraidos del XML:
    */
    private HashMap<String,PackageData> packages = null;
    
    /**
     * Vector con los elementos que se muestran el la lista del formulario:
     */
    private Vector<MyListElement> elementos_lista = new Vector();
    
    //Actualizador:
    private Updater actualizador = new Updater();
  
    //Array de paquetes necesarios para Madagascar:
    private Vector<PackageData> paquetesNecesarios;
    
    
    /** Creates new form GUIUpdate */
    public GUIUpdate(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();    
    }
        
    /**
     * Establece la informacion del servicio CubeFS: version, nombre interno...
     */
    public void setDataService(Vector<PackageData> datos) { paquetesNecesarios = datos; }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jScrollPane2 = new javax.swing.JScrollPane();
        lista = new javax.swing.JList();
        BtComprobar = new javax.swing.JButton();
        BtActualizar = new javax.swing.JButton();
        BtCancelar = new javax.swing.JButton();
        Logo = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        TxDescripcion = new javax.swing.JTextPane();
        TxDescripcion.setContentType("text/html");
        LbTituloDescripcion = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        LbTitulo = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Actualizaciones");
        setLocationByPlatform(true);
        setResizable(false);
        lista.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        lista.setCellRenderer(new MyCellRenderer());
        lista.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                listaKeyReleased(evt);
            }
        });
        lista.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                listaMouseClicked(evt);
            }
        });

        jScrollPane2.setViewportView(lista);

        BtComprobar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/madagascar/recursos/find_16x16.png")));
        BtComprobar.setText("Comprobar");
        BtComprobar.setToolTipText("Comprueba si existen actualizaciones.");
        BtComprobar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BtComprobarActionPerformed(evt);
            }
        });

        BtActualizar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/madagascar/recursos/recycled_16x16.png")));
        BtActualizar.setText("Actualizar");
        BtActualizar.setEnabled(false);
        BtActualizar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BtActualizarActionPerformed(evt);
            }
        });

        BtCancelar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/madagascar/recursos/button_cancel_16x16.png")));
        BtCancelar.setText("Cancelar");
        BtCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BtCancelarActionPerformed(evt);
            }
        });

        Logo.setIcon(new javax.swing.ImageIcon(getClass().getResource("/madagascar/recursos/recycled_128x128.png")));

        TxDescripcion.setEditable(false);
        jScrollPane1.setViewportView(TxDescripcion);

        LbTituloDescripcion.setText("Descripci\u00f3n de la actualizaci\u00f3n:");

        jLabel1.setText("Lista de paquetes nuevos:");

        LbTitulo.setFont(new java.awt.Font("Dialog", 1, 24));
        LbTitulo.setText("mantenga Madagascar actualizado.");

        jLabel3.setText("Las actualizaciones software corrigen errores y a\u00f1aden nuevas ");

        jLabel4.setText("funcionalidades.");

        jLabel2.setFont(new java.awt.Font("Dialog", 1, 10));
        jLabel2.setText("Boton derecho del raton para seleccionar paquetes.");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(BtComprobar)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(BtActualizar)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(BtCancelar))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 658, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(LbTituloDescripcion)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 658, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(Logo)
                        .addGap(52, 52, 52)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(LbTitulo)
                            .addComponent(jLabel3)
                            .addComponent(jLabel4)))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jLabel2)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(Logo)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 29, Short.MAX_VALUE)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel1)
                            .addComponent(jLabel2)))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(26, 26, 26)
                        .addComponent(LbTitulo)
                        .addGap(28, 28, 28)
                        .addComponent(jLabel3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel4)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(22, 22, 22)
                .addComponent(LbTituloDescripcion)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 159, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(24, 24, 24)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(BtCancelar)
                    .addComponent(BtActualizar)
                    .addComponent(BtComprobar))
                .addContainerGap())
        );
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-692)/2, (screenSize.height-614)/2, 692, 614);
    }// </editor-fold>//GEN-END:initComponents

    private void BtActualizarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BtActualizarActionPerformed
         doUpdate();
    }//GEN-LAST:event_BtActualizarActionPerformed

    private void listaKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_listaKeyReleased
        selectPackage();
    }//GEN-LAST:event_listaKeyReleased

    private void listaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_listaMouseClicked
       selectPackage();
       /**
        * BOTON DERECHO DEL RATON:
        * Permite seleccionar el paquete a actualizar. Si el paquete estaba previamente seleccionado elimina su seleccion.
        */
       int seleccionado = lista.getSelectedIndex();
       if(evt.getButton()==evt.BUTTON3 && seleccionado>=0)
        {

           ((MyListElement)lista.getModel().getElementAt(seleccionado)).setSelected();
           if(((MyListElement)lista.getModel().getElementAt(seleccionado)).isSelected())
               selectPackageCount++;
           else selectPackageCount--;
                   
           if(selectPackageCount>0) BtActualizar.setEnabled(true);
           else BtActualizar.setEnabled(false);
                   
           lista.repaint();
        }
            
    }//GEN-LAST:event_listaMouseClicked

    private void BtCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BtCancelarActionPerformed
        setVisible(false);
    }//GEN-LAST:event_BtCancelarActionPerformed

    private void BtComprobarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BtComprobarActionPerformed
        
        this.setCursor(new Cursor(Cursor.WAIT_CURSOR));
        PackageData paquete_descargado;
        
        try 
        {      
            actualizador.getUpdate(URL_UPDATER);
            
            //Obtenemos la lista de paquetes:
            packages = actualizador.getPackageData();
           
            if(packages.size()==0)
                LbTitulo.setText("Su sistema está actualizado.");
            else
            {
                for(PackageData paquete_requerido: paquetesNecesarios)
                {
                    paquete_descargado = packages.get(paquete_requerido.internal_name);
                    
                    if(paquete_descargado!=null && !paquete_requerido.compareVersion(paquete_descargado))
                    {
                        //Añadimos a la informacion del paquete descargado el nombre publico.
                        paquete_descargado.public_name = paquete_requerido.public_name;        
                        elementos_lista.add(new MyListElement(paquete_requerido.public_name, paquete_descargado));
                    }
                   
                    /*for(PackageData paquete_descargado : packages)
                    {
                        if(paquete_requerido.internal_name.equals(paquete_descargado.internal_name))
                            if(!paquete_requerido.compareVersion(paquete_descargado))
                            {
                                //Añadimos a la informacion del paquete descargado el nombre publico.
                                paquete_descargado.public_name = paquete_requerido.public_name;
                                
                                elementos_lista.add(new MyListElement(paquete_requerido.public_name, paquete_descargado));
                                break;
                            }
                    }*/
                }
                lista.setListData(elementos_lista);
            }
            
        } catch (IOException ex) { LbTitulo.setText("Error al obtener las actualizaciones."); }
        
        this.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));        
    }//GEN-LAST:event_BtComprobarActionPerformed
    
    /**
     * Muesta la informacion del paquete seleccionado en el TxDescription.
     */
    private void selectPackage()
    {
            int seleccionado = lista.getSelectedIndex();
            if(seleccionado>=0)
            {
                String nombre ="<b>Nombre: </b>"+((MyListElement)lista.getModel().getElementAt(seleccionado)).getPackageInfo().internal_name+"<br>";
                String version ="<b>Version: </b>"+((MyListElement)lista.getModel().getElementAt(seleccionado)).getPackageInfo().version_main+"."+
                                ((MyListElement)lista.getModel().getElementAt(seleccionado)).getPackageInfo().version_second+
                                "."+((MyListElement)lista.getModel().getElementAt(seleccionado)).getPackageInfo().version_rev+"<br>";
                String size ="<b>Tamaño del paquete: </b>"+((MyListElement)lista.getModel().getElementAt(seleccionado)).getPackageInfo().size+" bytes.<br>";
                String autor ="<b>Autor: </b>"+((MyListElement)lista.getModel().getElementAt(seleccionado)).getPackageInfo().author+"<br>";
                String copyright ="<b>Copyright: </b>"+((MyListElement)lista.getModel().getElementAt(seleccionado)).getPackageInfo().copyright+"<br>";
                String descripcion_paquete ="<b>Descripcion: </b>"+((MyListElement)lista.getModel().getElementAt(seleccionado)).getPackageInfo().description+"<br>";
                String cambios ="<b>Novedades: </b>"+((MyListElement)lista.getModel().getElementAt(seleccionado)).getPackageInfo().history+"<br>";

                String descripcion ="<html><body style=\"font-family: verdana, arial\">"+nombre+
                                                            version+
                                                            autor+
                                                            size+
                                                            copyright+
                                                            descripcion_paquete+
                                                            cambios+
                                    "</body></html>";
                TxDescripcion.setText(descripcion);
            }
    }
    
    private void doUpdate()
    {
        //Numero de componentes de la lista mostrada en el formulario:
        int countComponent = lista.getModel().getSize();
        //Elemento de la lista:
        MyListElement elemento = null;
        //Referencia al fichero temporal:
        File tempfile = null;
        
        Vector<Pair<String,File>> archivosTemporales = new Vector();
        
        /**
         * Indica si ha ocurrido algun error durante la descarga de paquetes.
         * Esto da la opcion al usuario de actualizar los paquetes correctos o
         * cancelar toda la actualizacion.
         */
        boolean anyError = false;
        
        /*Almacena los nombres interno de los paquetes de los que dependen
        los paquetes seleccionados. Formato de almacen: <nombre_interno,datos del paquete>*/
        HashMap<String,PackageData> paquetesDependientes = new HashMap();
        
        GUIProgressUpdate formInfoProgress = new GUIProgressUpdate((Frame) this.getParent(), false);
        
        for(int index=0;index<countComponent; index++)
        {
            elemento = ((MyListElement)lista.getModel().getElementAt(index));
            
            if(elemento.isSelected())
            {
                try 
                {
                    tempfile = File.createTempFile(tempFilesPrefix, "."+Postman.extensionTempFile, new File(Postman.getCubeDirectoryRoot()
                                                   +File.separator+Postman.directoryTemporal));       
                } 
                catch (IOException ex) 
                {
                    JOptionPane.showMessageDialog(this,"Se ha producido un error al escribir en el directorio de temporales.\nLas actualizaciones se cancelaron."
                                                  ,"Error",JOptionPane.ERROR_MESSAGE);
                    return;
                }
                    
                    boolean download_ok = false;
                    
                    //Extraemos la informacion de los paquetes dependientes:
                    PackageData paquete_descargado;
                    for(String nombreInterno : elemento.getPackageInfo().dependences)
                    {   //Buscamos el paquete en el vector de paquetes descargados:
                        paquete_descargado = packages.get(nombreInterno);
                        
                        //Vemos si tenemos ese paquete instalado y en caso afirmativo comprobamos version:
                        for(PackageData paquete_requerido: paquetesNecesarios)
                        {
                            if(paquete_descargado!=null && paquete_requerido.internal_name.equals(paquete_descargado.internal_name) && 
                                                        !paquete_requerido.compareVersion(paquete_descargado) )
                            {
                                paquetesDependientes.put(nombreInterno,paquete_descargado);
                            }
                        }
                        
                        
                    }
                       
                    
                    for(String mirror : elemento.getPackageInfo().mirror)
                    {
                        try 
                        { 
                            formInfoProgress.setVisible(true);
                            formInfoProgress.setPackagename(elemento.getPackageInfo().public_name);
                            actualizador.downloadFileByHttp(elemento.getPackageInfo().mirror.elementAt(0),tempfile); 
                            if(tempfile.length()==elemento.getPackageInfo().size)
                            {
                                download_ok = true;
                                archivosTemporales.add( new Pair(elemento.getPackageInfo().internal_name, tempfile) );
                                
                               
                                
                                break;
                            }
                        }
                        catch(IOException ex){}
                    }
                    
                    if(!download_ok)
                    {
                        anyError = true;
                        JOptionPane.showMessageDialog(this,"Al descargar el paquete: "+elemento.getPackageInfo().public_name+
                                                      ".","Error",JOptionPane.ERROR_MESSAGE);
                    }
                    
                    tempfile.deleteOnExit();
            }
        }
        
        formInfoProgress.setVisible(false);
        /**
         *  DESCARGA Y SUSTITUCION DE PAQUETES
         */ 
        
        if(anyError && archivosTemporales.size()>0)
        {
            int res = JOptionPane.showConfirmDialog(this,"Se han producido errores en la descarga de paquetes. ¿Desea continuar con la actualización?",
                                          "Sistema de actualizaciones",JOptionPane.YES_NO_OPTION);
            
            if(res == JOptionPane.NO_OPTION) return; 
        }
        
        /**
         *  INFORMAMOS DE LAS DEPENDENCIAS:
         */
        if(paquetesDependientes.size()>0)
        {
            int res = JOptionPane.showConfirmDialog(this,"Se van a instalar "+paquetesDependientes.size()+" dependencias. ¿Desea continuar con la actualización?",
                                          "Sistema de actualizaciones",JOptionPane.YES_NO_OPTION);
            
            if(res == JOptionPane.NO_OPTION) return; 
            
            for(PackageData elPaquete: paquetesDependientes.values())
            {
                try 
                {
                    tempfile = File.createTempFile(tempFilesPrefix, "."+Postman.extensionTempFile, new File(Postman.getCubeDirectoryRoot()
                                                   +File.separator+Postman.directoryTemporal));       
                } 
                catch (IOException ex) 
                {
                    JOptionPane.showMessageDialog(this,"Se ha producido un error al escribir en el directorio de temporales.\nLas actualizaciones se cancelaron."
                                                  ,"Error",JOptionPane.ERROR_MESSAGE);
                    return;
                }
                
                for(String mirror : elPaquete.mirror)
                {
                            boolean download_ok = false;
                            try 
                            { 
                                formInfoProgress.setVisible(true);
                                formInfoProgress.setPackagename(elPaquete.public_name);
                                actualizador.downloadFileByHttp(elPaquete.mirror.elementAt(0),tempfile); 
                                if(tempfile.length()==elemento.getPackageInfo().size)
                                {
                                    /*
                                     * @todo: COMPROBAR LA INTEGRIDAD DEL PAQUETE: SHA1.
                                     */
                                    download_ok = true;
                                    archivosTemporales.add(new Pair(elPaquete.internal_name, tempfile));
                                }
                            }
                            catch(IOException ex){}
                            
                            if(!download_ok)
                            {
                               
                               res = JOptionPane.showConfirmDialog(this,"Al descargar el paquete: "+elPaquete.public_name+
                                                      ".\n ¿Desea continuar con la actualización?","Error",JOptionPane.YES_NO_OPTION);
                               if(res == JOptionPane.NO_OPTION) { formInfoProgress.setVisible(false); return; }
                            }
                }
                
            }
            //Cerramos el formulario de progreso:
            formInfoProgress.setVisible(false);
            
        }
        
        //Copiamos los paquetes al directorio /lib de Cube:
        for(Pair<String,File> parDatos : archivosTemporales)
        {
            try {
                if(parDatos.element1().equals("Madagascar_000"))    //Descomprimimos en el directorio de madagascar:
                    util.descompressZip(parDatos.element2(),new File (Postman.getAppRoot()));
                else
                    util.descompressZip(parDatos.element2(),new File (Postman.getCubeDirectoryRoot()+File.separator+Postman.directoryLib));
            } catch (IOException ex) {
                JOptionPane.showMessageDialog(this,"Se ha producido un error al realizar la actualización real de los paquetes."
                                                  ,"Error",JOptionPane.ERROR_MESSAGE);
            }
        }
        
         JOptionPane.showMessageDialog(this,"Para que las actualizaciones tengan efecto, reinicie Madagascar."
                                                  ,"Actualización OK",JOptionPane.INFORMATION_MESSAGE);
        this.setVisible(false);
    }
   
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton BtActualizar;
    private javax.swing.JButton BtCancelar;
    private javax.swing.JButton BtComprobar;
    private javax.swing.JLabel LbTitulo;
    private javax.swing.JLabel LbTituloDescripcion;
    private javax.swing.JLabel Logo;
    private javax.swing.JTextPane TxDescripcion;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JList lista;
    // End of variables declaration//GEN-END:variables
    
}

/**
 *  INNER CLASS
 */

 class MyCellRenderer extends JCheckBox implements ListCellRenderer {
     //Imagen paquete seleccionado:
     private final  ImageIcon icon2 = new javax.swing.ImageIcon(getClass().getResource("/madagascar/recursos/button_ok_16x16.png"));
     //Imagen paquete No seleccionado:
     private final  ImageIcon icon1 = new javax.swing.ImageIcon(getClass().getResource("/madagascar/recursos/package.png"));
     private Vector<String> toinstall;
     
     public void setDataToInstal(Vector<String> data){this.toinstall = data;}

     public Component getListCellRendererComponent(
       JList list,              // the list
       Object value,            // value to display
       int index,               // cell index
       boolean isSelected,      // is the cell selected
       boolean cellHasFocus)    // does the cell have focus
     {
         
         
          setBackground(list.getBackground());
          setForeground(list.getForeground());
             
         if( ((MyListElement)value).isSelected() ) setIcon(icon2);
         else setIcon(icon1);
         
    
         String s = value.toString();
         setText(s);
            
         setEnabled(list.isEnabled());
         setFont(list.getFont());
         setOpaque(true);
         return this;
     }
 }
 
 /**
  * Elemento del jlist. Simplemente es una clase que almacena si un objetos se selecciono
  * para actualizar.
  */
 class MyListElement
 {
     private String texto = "";
     private boolean selected = false;
     private PackageData datos_paquete;
     
     /**
      * No utilizarlo.
      */
     public MyListElement(){}
     
     public MyListElement(String texto, PackageData datos_paquete){ this.texto = texto; this.datos_paquete = datos_paquete; }
     
     /**
      * Permite consultar si el elementos esta seleccionado.
      */
     public boolean isSelected() { return selected; }
     /**
      * Operacion NOT sobre la variable booleana de seleccion.
      */
     public void setSelected(){ selected = !selected; }
     /**
      * Devuelve la informacion del paquete asociada al elemento.
      */
     public PackageData getPackageInfo(){ return datos_paquete; }
     /**
      * Texto del elemento.
      */
     public String toString() { return texto; }
 }