/*
 * GUIaddCertified.java
 *
 * Created on 26 de octubre de 2007, 10:22
 */

package madagascar;

import cube.common.postman.Postman;
import java.awt.Component;
import java.awt.Container;
import java.awt.Frame;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.cert.Certificate;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;
import java.security.spec.InvalidKeySpecException;
import java.util.Enumeration;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.ListCellRenderer;

/**
 *
 * @author  victor
 */
public class GUIaddCertified extends javax.swing.JDialog {
    
    /** Creates new form GUIaddCertified */
    public GUIaddCertified(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();

        refreshLista();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        logo = new javax.swing.JLabel();
        Lbtexto1 = new javax.swing.JLabel();
        LbTexto2 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        lista = new javax.swing.JList();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        TxDatosCert = new javax.swing.JTextPane();
        TxDatosCert.setContentType("text/html");
        jLabel3 = new javax.swing.JLabel();
        BtOk = new javax.swing.JButton();
        Btremove = new javax.swing.JButton();
        BtCert = new javax.swing.JToggleButton();
        BtCA = new javax.swing.JButton();

        setTitle("Administrador de certificados");
        setResizable(false);
        logo.setIcon(new javax.swing.ImageIcon(getClass().getResource("/madagascar/recursos/candado_128x128.png")));

        Lbtexto1.setText("El administrador de certificados permite a\u00f1adir o eliminar ");

        LbTexto2.setText("Certificados y entidades certificadoras empleadas por Cube");

        lista.setCellRenderer(new MyCellRenderer_cert());
        lista.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                listaMouseClicked(evt);
            }
        });

        jScrollPane1.setViewportView(lista);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Informaci\u00f3n del certificado"));
        TxDatosCert.setEditable(false);
        jScrollPane2.setViewportView(TxDatosCert);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 517, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 206, Short.MAX_VALUE)
                .addContainerGap())
        );

        jLabel3.setText("Lista certificados:");

        BtOk.setIcon(new javax.swing.ImageIcon(getClass().getResource("/madagascar/recursos/button_ok_16x16.png")));
        BtOk.setText("Aceptar");
        BtOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BtOkActionPerformed(evt);
            }
        });

        Btremove.setIcon(new javax.swing.ImageIcon(getClass().getResource("/madagascar/recursos/delete_16x16.png")));
        Btremove.setToolTipText("Eliminar certificado.");
        Btremove.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BtremoveActionPerformed(evt);
            }
        });

        BtCert.setIcon(new javax.swing.ImageIcon(getClass().getResource("/madagascar/recursos/calendar_add_16x16.png")));
        BtCert.setToolTipText("A\u00f1adir certificado.");
        BtCert.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BtCertActionPerformed(evt);
            }
        });

        BtCA.setIcon(new javax.swing.ImageIcon(getClass().getResource("/madagascar/recursos/vcard_add_16x16.png")));
        BtCA.setToolTipText("A\u00f1adir entidad certificadora.");
        BtCA.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BtCAActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 551, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(logo)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(Lbtexto1)
                            .addComponent(LbTexto2)))
                    .addComponent(jLabel3)
                    .addComponent(BtOk, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(BtCA, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(BtCert, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(Btremove, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(logo))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(38, 38, 38)
                        .addComponent(Lbtexto1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(LbTexto2)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel3)
                .addGap(1, 1, 1)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(8, 8, 8)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(Btremove)
                    .addComponent(BtCert)
                    .addComponent(BtCA))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(BtOk)
                .addContainerGap())
        );
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-585)/2, (screenSize.height-660)/2, 585, 660);
    }// </editor-fold>//GEN-END:initComponents
    /**
     *Elimina un certificado.
     */
    private void BtremoveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BtremoveActionPerformed
        int seleccionado = lista.getSelectedIndex();
        if(seleccionado>=0)
        {
            String alias = ((MyListElement_cert)lista.getModel().getElementAt(seleccionado)).getAlias();
            try {
                Postman.GetRefCryptography().subEntry(alias);
                Postman.GetRefCryptography().saveCertStore();
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(this,"Se ha producido un error al eliminar el certificado."
                                                  ,"Error",JOptionPane.ERROR_MESSAGE);
            }
            TxDatosCert.setText("");
           
            refreshLista();
        }
    }//GEN-LAST:event_BtremoveActionPerformed

    private void BtOkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BtOkActionPerformed
        this.setVisible(false);
    }//GEN-LAST:event_BtOkActionPerformed

    private void listaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_listaMouseClicked
        showData();
    }//GEN-LAST:event_listaMouseClicked

    private void BtCAActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BtCAActionPerformed
        try {
            addCA();
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(this,"Se ha producido un error al almacenar el certificado de CA."
                                                  ,"Error",JOptionPane.ERROR_MESSAGE);
        } 
    }//GEN-LAST:event_BtCAActionPerformed

    private void BtCertActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BtCertActionPerformed
        addCert();
    }//GEN-LAST:event_BtCertActionPerformed
    

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton BtCA;
    private javax.swing.JToggleButton BtCert;
    private javax.swing.JButton BtOk;
    private javax.swing.JButton Btremove;
    private javax.swing.JLabel LbTexto2;
    private javax.swing.JLabel Lbtexto1;
    private javax.swing.JTextPane TxDatosCert;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JList lista;
    private javax.swing.JLabel logo;
    // End of variables declaration//GEN-END:variables
    
    private void addCA() throws KeyStoreException, CertificateException, FileNotFoundException
    {
        int retorno;
        String archivo;
        
        GUIOpenCert opendialog = new GUIOpenCert((Frame)this.getParent(),true);
        opendialog.setTipo(GUIOpenCert.CA_CERT);
        opendialog.setVisible(true);
        
        if(opendialog.getOption()==1)
        {
            Postman.GetRefCryptography().addCA(opendialog.getAlias(),new File(opendialog.getCertificado()));
            try {
                    Postman.GetRefCryptography().saveCertStore();
                } catch (Exception ex) {
                    JOptionPane.showMessageDialog(this,"Se ha producido un error al volcar el contenido del almacen de certificados."
                                                  ,"Error",JOptionPane.ERROR_MESSAGE);
                } 
                refreshLista();
        }
    }
    
    /**
     *@todo Implementar la extraccion de la cadena de certificados y almacenarla en el keystore.
     */
    private void addCert()
    {
        int retorno;
        String archivo;
        
        GUIOpenCert opendialog = new GUIOpenCert((Frame)this.getParent(),true);
        opendialog.setTipo(GUIOpenCert.USER_CERT);
        opendialog.setVisible(true);
        
        if(opendialog.getOption()==1)
        {
            try {
                Postman.GetRefCryptography().addUserCertificate(opendialog.getAlias(),new File(opendialog.getClavePrivada()),new File(opendialog.getCertificado()),null);
                try {
                    Postman.GetRefCryptography().saveCertStore();
                } catch (Exception ex) {
                    JOptionPane.showMessageDialog(this,"Se ha producido un error al volcar el contenido del almacen de certificados."
                                                  ,"Error",JOptionPane.ERROR_MESSAGE);
                } 
                refreshLista();
            }
            catch(InvalidKeySpecException ex)
            {
                JOptionPane.showMessageDialog(this,"Se ha producido un error al leer la clave privada."
                                                  ,"Error",JOptionPane.ERROR_MESSAGE);
            }
            catch (KeyStoreException ex) {
                JOptionPane.showMessageDialog(this,"Se ha producido un error en el almacen de certificados."
                                                  ,"Error",JOptionPane.ERROR_MESSAGE);
            } catch (IOException ex) {
                JOptionPane.showMessageDialog(this,"Error de lectura/escritura."
                                                  ,"Error",JOptionPane.ERROR_MESSAGE);
            }
        }
        
    }
    
    private void showData()
    {
        String cabecera = "<html><body style=\"background-color:rgb(245, 245, 220)\">";
        String pie ="</body></html>";
        
        
        int seleccionado = lista.getSelectedIndex();
        if(seleccionado>=0)
        {
             X509Certificate elCertificado = ((MyListElement_cert)lista.getModel().getElementAt(seleccionado)).getCert();
             
             //Datos del sujeto:
             String [] datos_sujeto = elCertificado.getSubjectX500Principal().toString().split(",");
             //Detos de la autoridad:
             String [] datos_CA = elCertificado.getIssuerX500Principal().toString().split(",");
            
             String serie = "<b>Numero de serie: </b>"+((MyListElement_cert)lista.getModel().getElementAt(seleccionado)).getCert().getSerialNumber().toString()+"<br>";
             String algoritmo = "</b>Algoritmo de firmado: </b>"+((MyListElement_cert)lista.getModel().getElementAt(seleccionado)).getCert().getSigAlgName()+"<br>";
            
             
            
            TxDatosCert.setText(cabecera+"<p style=\"background-color:rgb(240, 230, 140)\"><b>Emitido para:</b></p>"+
                                "<p style=\"background-color:rgb(245, 245, 220)\">"+datos_sujeto[1]+"<br>"+
                                datos_sujeto[3]+"<br>"+
                                datos_sujeto[2]+"<br>"+
                                datos_sujeto[0]+"<br></p>"+
                                "<p style=\"background-color:rgb(240, 230, 140)\"><b>Emitido por:</b></p>"+
                                "<p style=\"background-color:rgb(245, 245, 220)\">"+datos_CA[1]+"<br>"+
                                datos_CA[3]+"<br>"+
                                datos_CA[2]+"<br>"+
                                datos_CA[0]+"<br>"+"</p>"+
                                pie);
        }
    }
    /**
     * Refresca la lista de los certificados.
     */
    private void refreshLista()
    {
        Vector<MyListElement_cert> elementosLista = new Vector();
        Enumeration<String> enumeracion = Postman.GetRefCryptography().getAliases();
        
        while(enumeracion.hasMoreElements())
        {
             String alias = enumeracion.nextElement();
             X509Certificate elCertificado = Postman.GetRefCryptography().getCertificate(alias);
             String [] datos = elCertificado.getSubjectX500Principal().toString().split(",");
             elementosLista.add(new MyListElement_cert(datos[1],alias ,Postman.GetRefCryptography().isCAcert(alias),elCertificado));
        }
       
        lista.setListData(elementosLista);
        lista.repaint();
    }
}

