/*
 * Acciones_filemanager.java
 *
 * Created on 7 de septiembre de 2007, 14:11
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package service.cubefs;

import cube.common.services.Impl_service;
import java.util.AbstractMap;
import java.util.HashMap;
import rice.Continuation;

/**
 * Esta clase es de uso interno.
 * Se le debe pasar una referencia al controlador de tareas (Task) y
 * a la estructura de datos con la informacion de las tareas activas.
 * @author victor Puertas.
 */
class Acciones_filemanager implements Continuation
    {    
        //Referencia al controlador de tareas:
        Task task;
        /**
         * Referencia a la estructura de datos que almacena la informacion de los trabajos
         * actuales.
         */
         AbstractMap<String, Data_FileState> ref_archivos;
        
        //Identificador del fichero asociado a la tarea:
         String fileID;
        
        /**
         * Acciones a realizar en caso de resultado faborable.
         */
        public void receiveResult(Object object) {
            ReportFile resultados = (ReportFile) object;
            System.out.println("FileManager>> Tarea terminada");
            System.out.println("\tfileID: "+resultados.fileID.toString());
            System.out.println("\tArchivo fs: "+resultados.fsFile);
            System.out.println("\tTrack ok: "+ resultados.trackOK);
            System.out.println("\tTrack bad: "+ resultados.badTrack);
            System.out.println("\tCopias insertadas: "+ resultados.backupTrack);
            //ref_archivos.remove(fileID);
            task.getFileManager(fileID).close(Impl_service.TERMINATE_NOW);
            task.subFileManager(fileID);
        }
        
        /**
         * Acciones a realizar en caso de error.
         */
        public void receiveException(Exception ex) {
           /* if(ex instanceof java.lang.ClassCastException)
            {
                System.out.println("FileManager>>Fragmetos del fileID: "+fileID+" incompatibles con el tipo de persistencia acutal."); 
            }
            else*/
            System.out.println("FileManager-exception.");
            
            //ref_archivos.remove(fileID);
            try
            {
                task.getFileManager(fileID).close(Impl_service.TERMINATE_NOW);
                task.subFileManager(fileID);
            }
            catch(NullPointerException err){}
        }
        
    }
