/*
* Title			:   ReportFile.java
* Package		:   service.cubefs
* Project		:   Cube Platform
* version               :   Alfa 0
* Description           :   Contiene un resumen de los datos relevantes tras la subida o descarga
*                           de un archivo en el anillo.
*          
*                           		
* Created on            :   02/07/2007 
* Author		:   Victor Puertas Garcia.
* Copyright		:   (c) 2007, Victor Puertas Garcia. vpgugr@gmail.com 
* 					   
* 
* This program is free software; you can redistribute it and/or modify it under
* the terms of the GNU General Public License as published by the Free Software
* Foundation; either version 2 of the License, or (at your option) any later  version.
* See the GNU General Public License (http://www.gnu.org/copyleft/gpl.html)for more details.
* 
* HISTORIAL DE CAMBIOS. Formato: <fecha> <autor> <descripcion>
*
*
*/

package service.cubefs;

/**
 * Contiene un resumen de los datos relevantes tras la subida o descarga
 * de un archivo en el anillo.
 * @author victor Puertas.
 */
public class ReportFile implements Cloneable{   
    
    /**
     * Identificador del archivo con el que se ha operado.
     */
    public FileID fileID = null;
    /**
     * Numero de fragmentos operados con exito.
     */
    public long trackOK = 0;
    /**
     * Numero de fragmentos erroneos.
     */
    public long badTrack = 0;
    /**
     * Numero de copias totales.
     */
    public long backupTrack = 0;
    /**
     * Nombre del fichero fs.
     */
    public String fsFile;
    
    /** Crea una nueva instancia. */
    public ReportFile(FileID fileID, long trackOK, long badTrack, long backupTrack, String fsFile) {
        this.fileID = fileID;
        this.trackOK = trackOK;
        this.badTrack = badTrack;
        this.backupTrack = backupTrack;
        this.fsFile = fsFile;
    }  
    
    /**
      * Permite clonar el objeto.
      */
     public Object clone()
     {
         ReportFile obj = null;
        try 
        {
            obj = (ReportFile) super.clone();
        } catch (CloneNotSupportedException ex) {
            //Solo en depuracion
            System.err.println("No se puede clonar el ReportFile.");
        }
         
        obj.fsFile = new String(this.fsFile);
        obj.fileID = (FileID) this.fileID.clone();
        return obj; 
     }
}
