/*
 * CubeNodeChainIdFactory.java
 *
 * Created on 16 de noviembre de 2007, 15:08
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package cube.common.pastry;

import cube.common.security.Cryptography;
import java.security.NoSuchAlgorithmException;
import rice.pastry.Id;
import rice.pastry.NodeIdFactory;

/**
 *
 * @author victor
 */
public class CubeNodeChainIdFactory implements NodeIdFactory {
    private String chain = "";
    
    /** Creates a new instance of CubeNodeChainIdFactory */
    public CubeNodeChainIdFactory(String chain) { this.chain = chain; }

    public Id generateNodeId() {
        try 
        {    
            if(chain==null) return null;   
            return Id.build(Cryptography.digestSHA1(chain.getBytes()));       
        } catch (NoSuchAlgorithmException ex) {
            System.err.println("CubeNodeChainIdFactory>> No se puede generar el identificador de nodo.");
            return null;
        }       
    }
    
}
