/*
* Title			:   Impl_service.java
* Package		:   cube.common.services
* Project		:   Cube Platform
* version               :   Alfa 0
* Description           :   Metodos basicos para implementar un servicio.             
*                           		
* Created on            :   30/06/2007 
* Author		:   Victor Puertas Garcia.
* Copyright		:   (c) 2007, Victor Puertas Garcia. vpgugr@gmail.com 
* 					   
* 
* This program is free software; you can redistribute it and/or modify it under
* the terms of the GNU General Public License as published by the Free Software
* Foundation; either version 2 of the License, or (at your option) any later  version.
* See the GNU General Public License (http://www.gnu.org/copyleft/gpl.html)for more details.
* 
* HISTORIAL DE CAMBIOS. Formato: <fecha> <autor> <descripcion>
*
*
*/
package cube.common.services;

/**
 * Define los metodos basicos que debe poseer la implementacion de un servicio, es decir, la interface del servicio
 * de cara al gestor de mensajes.
 * @author victor Puertas.
 */
public abstract class Impl_service {
    /**
     * Terminacion No-inmediata.
     */
    static public final byte TERMINATE = 0;
    /**
     * Terminacion Inmediata.
     */
    static public final byte TERMINATE_NOW = 1;
    

    
    /**
     * Método que comienza el servicio. En el estaria el main.
     */
    abstract public void ServiceStart(Object param);
    /**
     * Metodo que se invoca cuando se debe cerrar el servicio. En el deben de estar las acciones necesarias
     * antes de cerrar.
     * @param tipo Define el tipo de salida: <B>Inmediata</B> o <B>No-Iinmediata</B>. En las No-inmediatas se
     * permite al servicio poder terminar las tareas pendientes.
     */
    abstract public void ServiceStop(byte tipo);
    /**
     * Retorna el conjunto de propiedades de entorno del nodo en el que se encuentra lanzado el servicio.
     */
    abstract public rice.environment.Environment getNodeEnviroment ();   
}
