/*
 * PackageData.java
 *
 * Created on 17 de octubre de 2007, 13:45
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package cube.common.updater;

import java.util.Vector;

/**
 * Estructura que almacena la informacion de un paquete.
 * @author victor Puertas.
 */
public class PackageData implements  java.io.Serializable {
    
    /**
     * Nombre interno del paquete.
     */
    public String internal_name = "";
    /**
     * Nombre publico del paquete.
     */
    public String public_name = "";
    /**
     * Longitud en bytes del paquete.
     */
    public long size = 0;
    /**
     * Version principal del paquete.
     */
    public int version_main = 0; 
     /**
     * Version secundaria del paquete.
     */
    public int version_second = 0; 
     /**
     * Revision del paquete.
     */
    public int version_rev = 0; 
    /**
     * Nombre en clave de la version.
     */
    public String codename ="";
    /**
     * Nombre del autor del paquete.
     */
    public String author = "No author";
    /**
     * Copyright del paquete.
     */
    public String copyright = "No copyright";
    /**
     * Descripcion del paquete del paquete.
     */
    public String description = "No description";
    /**
     * Novedades y conjunto de cambios en el paquete.
     */
    public String history = "No data";
    /**
     * Direcciones de los servidores de descarga.
     */
    public Vector<String> mirror = new Vector();
    /**
     * Lista de los paquetes de los que depende:
     */
    public Vector<String> dependences = new Vector();
    /**
     * Fecha de la actualizacion.
     */
    //public int version = 0;
    
    /** Constructor. No hace nada. */
    public PackageData() {}
    
    /**
     * @return  true si la version del este objeto es mayor o ugual que la del pasado como parametro.<br>
     * false si la version es menor o igual.
     */
    public boolean compareVersion(PackageData obj)
    {
        if( version_main>obj.version_main) return true;
        else
            if (version_main<obj.version_main) return false; 
            else
                if( version_second>obj.version_second) return true;
                else
                    if( version_second<obj.version_second) return false;
                    else if( version_rev>obj.version_rev) return true;
                        else
                            if( version_rev<obj.version_rev) return false;
                            else return true;
    }

}
